#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D tex0;

varying vec2 tcoord;
varying vec4 color;


// Material IDs

const int FIRE = 0;
const int STEAM = 1;
const int AIR = 2;
const int WATER = 3;
const int SAND = 4;
const int WALL = 5;
const int PLANT = 6;
const int SMOLDER = 7;
const int NUM_MATERIALS = 8;

void main()
{
	vec3 outcolor;
	int material = int((texture2D(tex0, tcoord) * color).r * float(NUM_MATERIALS - 1) + 0.5);
	
	if      (material == FIRE   ) outcolor = vec3(1.0, 0.1, 0.0);
	else if (material == STEAM  ) outcolor = vec3(0.9, 0.9, 1.0);
	else if (material == AIR    ) outcolor = vec3(1.0, 1.0, 1.0);
	else if (material == WATER  ) outcolor = vec3(0.0, 0.7, 1.0);
	else if (material == SAND   ) outcolor = vec3(1.0, 0.8, 0.3);
	else if (material == WALL   ) outcolor = vec3(0.6, 0.6, 0.6);
	else if (material == PLANT  ) outcolor = vec3(0.2, 0.9, 0.0);
	else if (material == SMOLDER) outcolor = vec3(1.0, 0.5, 0.0);
	else outcolor = vec3(0, 0, 0);
	
	gl_FragColor = vec4(outcolor, 1);
}
